Problem with primary keys in MSSQL provider
2012-08-21 09:08 AM - Alexander Bruy

Status: Closed

Priority: Normal

Assignee: Tamas Szekeres

Category: Data Provider/MSSQL

Affected QGIS version:master Regression?: No
Operating System: all Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupls data: Copied to github as #: 15544
Description

Table has bigint primary key. When loading it to QGIS all field values are displayed as "ERROR", but identify tool works fine. Also table
reports correct number of features and field types detected correctly. Seems this related with possible integer overflow in nextFeature()
method (line 523).

From Qt docs

Warning: If the value is convertible to a LonglLong but is too large to be represented in an int, the resulting arithmetic overflow will not be
reflected in ok. A simple workaround is to use QString::tolnt(). Fixing this bug has been postponed to Qt 5 in order to avoid breaking
existing code.

Here is simple patch that should fix it

Associated revisions

Revision a21ad0f7 - 2012-08-28 01:50 PM - Alexander Bruy

fix #6235

History

#1 - 2012-08-22 04:01 AM - Alexander Bruy
- Category changed from Data Provider to Data Provider/MSSQL

#2 - 2012-08-27 12:36 PM - Evgeniy Nikulin

| tried the patch on qgis trunk (Fedora 17 x86_64) and MS SQL Server 2008 - it works. My tables with bigint keys well displayed in the table of attributes.

#3 - 2012-08-28 05:00 AM - Alexander Bruy
- Status changed from Open to Closed

Fixed in changeset commit:"a21ad0f7a19cce63529e561581f293159c0bec2c".

#4 - 2012-08-28 05:00 AM - Alexander Bruy

- Resolution set to fixed
